# RequestsPro

RequestsPro is the easy way to build professional-grade API clients.

## Key features

- Transparent authentication handling.
- Token persistence for use across multiple processes.
- Transparent token renewal and retry on 401 errors.
- Allow the use of custom JSON encoder and decoder to transparent handle complex types serialization.
- Consistent and transparent API error handling.
- Built-in http chatter audit.
- Separation of conserns everywhere.
- Extremelly composable to handle retries, rate limiting, sandboxing and more.

## Quick start

Check the [demo/eduzz.py](https://github.com/henriquebastos/requestspro/blob/main/demo/eduzz.py) to see a simple yet complete API client example.

## Install

```bash
pip install requestspro
```

## License

MIT License.

## Contributing

Pull requests are welcome and must have associated tests.

For major changes, please open an issue first to discuss what you would like to change.

## License

[MIT](https://choosealicense.com/licenses/mit/)

## Author

Henrique Bastos <henrique@bastos.net>

## Thank you to Routable

[Routable](https://routable.com) sponsored the development of this library.
Working at [Routable](https://routable.com) is an awesome experience, with a developer-first culture that fosters innovation and growth.
If you're interested in joining a dynamic team, [check out our job opportunities here](https://routable.com/careers/)!
